#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

long global_int_array[10][10];
long global_int_array_ind[10][10];
int global_num_recs;

int get_data(void) {
  EXEC SQL BEGIN DECLARE SECTION;
  long gid, int_array_ind[10], int_array[10];
  EXEC SQL END DECLARE SECTION;
  int rc;

  global_num_recs = 0;
  bzero(&global_int_array[0], sizeof(long) * 10);
  bzero(&global_int_array_ind[0], sizeof(long) * 10);

  EXEC SQL CONNECT TO int_array_testdb@localhost AS myconn USER postgres USING password;
  
  EXEC SQL AT myconn DECLARE recs CURSOR FOR SELECT gid, int_array FROM get_as_int_array();
  rc = sqlca.sqlcode;
  if(rc < 0) {
    printf("Error declare cursor\n");
    EXEC SQL DISCONNECT myconn;
    return rc;
  }

  EXEC SQL AT myconn OPEN recs;
  rc = sqlca.sqlcode;
  while(rc == 0) {
    EXEC SQL AT myconn FETCH NEXT FROM recs INTO :gid, :int_array :int_array_ind;
    rc = sqlca.sqlcode;
    if(rc == 0) {
      memcpy(&global_int_array[global_num_recs][0], &int_array[0], sizeof(long) * 10);
      memcpy(&global_int_array_ind[global_num_recs][0], &int_array_ind[0], sizeof(long) * 10);
      global_num_recs++;
    }
  }

  EXEC SQL AT myconn CLOSE recs;

  EXEC SQL DISCONNECT myconn;

  return 0;
}

int main(int argc, char *argv[]) {  
  int i;

  if(get_data() >= 0) {
    for(i = 0; i < global_num_recs; i++) {
      printf("{%ld, %ld, %ld, %ld, %ld, %ld, %ld, %ld, %ld, %ld}\n", global_int_array[i][0], global_int_array[i][1], global_int_array[i][2], global_int_array[i][3], global_int_array[i][4], global_int_array[i][5], global_int_array[i][6], global_int_array[i][7], global_int_array[i][8], global_int_array[i][9]);
    }
  }
  return 0;
}
